#!/usr/bin/perl
# cgi-irc v0.3.4 - http://cgiirc.sourceforge.net/
# (C) 1999-2000 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# This deals with the bottom frame, it takes the input and output over the
# unix-domain socket and prints a nice form for the user

use strict;
my $version="0.3.4";
use vars qw(%config %irc %colours %styles $channel $say $say2 $rand $sock $default_channel $style $mode);
use IO::Socket;
use CGI;
my $q = new CGI;
print $q->header();

# Change this if you change the location of the config file
$config{file}="config";

&config($config{file});
$rand=$q->param('r');
$rand=~ s/[^a-z,0-9]//g;
$channel=$q->param('c');
$channel =~ s/\n//g;
$style = $q->param('style');
$mode = $q->param('m');
&styles;

if($q->param('action') eq "form"){
   &print_form;
}elsif($q->param('action') eq "command"){
   $say=$q->param('say');
   $say =~ s/\n//g;
   $say2=$q->param('say2');
   $say2 =~ s/Names (#.*?)/\/quote names $1/;
   $say2 =~ s/\n//g;
   &connect_u($rand);
   ($config{channels},$default_channel,$config{nick},$config{server})=status_u();
   $config{topic} = topic_u($channel);
   if($channel ne $q->param('chan-default')){
	  &send_u("/chan $channel");
   }
   if($say){
	  &send_u("$say");
   }
   if($say2){
        &send_u("$say2");
   }
   &close_u;
   &print_form($channel);
}else{
   print "Error unknown action";
}

sub print_form{
   my $channel=shift;
   if($mode eq "basic"){
	  print <<EOF;
<html><body bgcolor="$colours{bgcolor}" text="$colours{text}">
<form name="myform" action="$ENV{SCRIPT_NAME}" method="Post"><input type="hidden" name="action" value="command"><input type="hidden" name="style" value="$style"><input type="hidden" name="chan-default" value="$channel"><input type="hidden" name="r" value="$rand"><input type="hidden" name="m" value="basic">
<select name="c">
EOF
foreach my $split(split(/ /,$config{channels})){
   next if $split eq "";
   my $default;
   if($channel eq $split){$default=" SELECTED";}
   print "<option name=\"$split\"$default>$split</option>";
   $default="";
}
print <<EOF;
</select><input type="text" name="say" size="50"><input type="submit" value=" Say "></form>
</body></html>
EOF
}else{
   my $escaped_channel=escapehtml($channel);
   my $escaped_topic=escapehtml($config{topic});
   print <<EOF;
<html>
<head>
  <title>Form</title>
</head>
<body
onload="document.myform.say.focus()" topmargin="0" leftmargin="0" bottommargin="0" rightmargin="0" 
bgcolor="$colours{bgcolor}" background="$config{imagepath}form-bg.gif" text="$colours{text}">
<table border="0" cellspacing="1" cellpadding="0">
    <tr>
	  <form>
      <td width="120" align="Center" valign="bottom" height="30">
      <input type="text" size="10" style="background-color: $colours{bgcolor}; font-weight: bold; 
color: $colours{text};" value="$config{nick}">
      </td>
      <td align="Left" valign="bottom" height="30">
      <font face="Arial" size="1">
      <input type="text" size="50" value="[$escaped_channel]
: [$escaped_topic]" style="background-color: $colours{bgcolor}; color: $colours{text};"></font></td>
      </form>
      <td align="left" valign="bottom" height="30">
      </td>
    </tr>
    <tr>
      <td width="120" align="Center" valign="bottom" height="30">
      <form name="myform" action="$ENV{SCRIPT_NAME}" method="Post">
      <input type="hidden" name="action" value="command">
      <input type="hidden" name="style" value="$style">
      <input type="hidden" name="chan-default" value="$channel">
      <input type="hidden" name="r" value="$rand">
      <select name="c">
EOF
foreach my $split(split(/ /,$config{channels})){
   next if $split eq "";
   my $default;
   if($channel eq $split){$default=" SELECTED";}
   print "<option name=\"$split\"$default>$split</option>";
   $default="";
}
print <<EOF;
      </select>
      </td>
      <td align="left" valign="bottom" height="30">
      <input type="text" name="say" size="50" style="background-color: #C0C0C0;">
      </td>
      <td align="left" valign="bottom" height="30"><input
alt="Say" border="0" src="$config{imagepath}button-say.gif" 
      type="image" width="50" height="25"></td></form>
    </tr>
    <tr>
      <td width="120" align="Center" valign="top" height="30"><font face="Arial" size="1">User IP
Address<br>
        $ENV{'REMOTE_ADDR'}\n</font></td>
      <td align="Left" valign="top" height="30">
      <table border="0" cellpadding="0" cellspacing="1">
          <tr>
            <td>
            </td>
            <td>
	  <form name="chanform" action="$ENV{SCRIPT_NAME}" method="Post">
	  <input type="hidden" name="action" value="command">
	  <input type="hidden" name="style" value="$style">
	  <input type="hidden" name="chan-default" value="$channel">
	  <input type="hidden" name="r" value="$rand">
	  <input type="hidden" name="say2" value="/part $channel">
	  <input alt="/Part" border="0" src="$config{imagepath}button-part.gif" type="image" 
	  width="75" height="20" align="top">
	  </form>
            </td>
            <td>
	  <form name="chanform" action="$ENV{SCRIPT_NAME}" method="Post">
	  <input type="hidden" name="action" value="command">
	  <input type="hidden" name="style" value="$style">
	  <input type="hidden" name="chan-default" value="$channel">
	  <input type="hidden" name="r" value="$rand">
	  <input type="hidden" name="say2" value="/quit">
	  <input alt="/Quit" border="0" src="$config{imagepath}button-quit.gif" type="image" 
	  width="75" height="20" align="top">
	  </form>
            </td>
          </tr>
      </table>
	  </form>
      </td>
      <td align="left" valign="top" height="30">
      </td>
    </tr>
</table>
</body>
</html>
EOF
}}

sub styles{
   if($style){
	  ($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp}) = split(/:/,$styles{$style});
   }else{
	  ($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp}) = split(/:/,$styles{$config{default_style}});
   }
}

sub error{
   my $error=shift;
   if($q->param('first') eq 11 and $error eq "Connection refused"){
	  print "<html><head><meta
http-equiv=\"Refresh\" content=\"5; $ENV{SCRIPT_NAME}?r=$rand\&first=11\&action=form\"><body
bgcolor=\"#ffffff\" text=\"#000000\">Loading...<br> Please wait</body></html>\n";
   }elsif($error eq "Connection refused"){
	  print "<html><head><body bgcolor=\"#ffffff\" text=\"#000000\"><a
href=\"irc.cgi\" target=\"_top\">Login again?</a></body></html>";
   }else{
	  print "$error\n";
	  &printform;
   }
   exit;
}

sub connect_u{
   my $random=shift;
   $sock = IO::Socket::UNIX->new(
      Peer => "$config{tmpfile_prefix}$random") or error($!);
}

sub status_u{
   print $sock "/STATUS\n";
   my($c,$d,$n,$s);
   $c=<$sock>;
   $d=<$sock>;
   $n=<$sock>;
   $s=<$sock>;
   chomp($c,$d,$n,$s);
   return($c,$d,$n,$s);
}

sub topic_u{
   print $sock "/UCTOPIC $_[0]\n";
   chomp(my $tmp=<$sock>);
   return $tmp
}

sub send_u{
   my $send=shift;
   print $sock $send,"\n";
}

sub close_u{
   print $sock "/CLOSESOCKET\n";
   close($sock);
}

sub escapehtml{
   my $tmp=shift;
   $tmp =~ s/</&lt;/g;
   $tmp =~ s/>/&gt;/g;
   $tmp =~ s/"/&quot;/g;
   return $tmp;
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or error("Unable to open config file");
   while(<CONFIG>){
      chomp;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);
}

