#!/usr/bin/perl
# cgi-irc v0.3.4 - http://cgiirc.sourceforge.net/
# (C) 2000 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# The main part of CGI:IRC this does all the server connection and all the
# input from the form (passed through a unix-domain socket from form.cgi)

# Some parts of this file have been taken from JIRC an irc bot frame work
# JIRC  Jerry's IRC Bot  1.02 -- 2000 July 6 -- Scott "Jerry" Lawrence
# Stuff from IO::Select man page too

$|++;
use IO::Socket;
use IO::Select;
use CGI;

# You may want to change the location of the config file
$config{file}="config";
$version="0.3.4";

$SIG{'HUP'}=\&closefiles;
$SIG{'INT'}=\&closefiles;
$SIG{'TERM'}=\&closefiles;

my $q=new CGI;

&init;
&main;
exit 0;

# -------------------- Init stuff -------------
sub init{
   &config($config{file});
   &rm_stale if $config{autocleanup};
   &styles;
   &nph_header;
   &check_referer if $config{referer};
   &check_ip;
   &cgi_input;
   if(-e "$config{tmpfile_prefix}$config{random}"){
      error("Communication socket already exists",$colours{client});
   }
   if($ENV{HTTP_USER_AGENT} =~ /^Mozilla.5/i){
	  $config{scroll} = "setTimeout('$config{scroll}', 1)";
   }
   html($config{welcome},$colours{client});
}

sub nph_header{
   $header=1;
   print "HTTP/1.0 200\n";
   print "Content-type: multipart/x-mixed-replace;boundary=BOUNDARY\n\n";
   # assume only msie is broken :)
   if($ENV{HTTP_USER_AGENT} !~ /MSIE/){
	   print "--BOUNDARY\n";
	   print "Content-type: text/html\n\n";
   }
   print <<EOF;
<html><head>
<title>CGI:IRC $version</title>
<META HTTP-EQUIV="Content-Script-Type" CONTENT="text/javascript">
<style>
.link  {color: #0000ff;}
body {
   scrollbar-face-color:#8FAFCF;
   scrollbar-arrow-color:#FFFFFF;
   scrollbar-track-color:$colours{bgcolor};
   scrollbar-shadow-color: #000000;
   scrollbar-darkshadow-color: #8FAFCF;
   scrollbar-highlight-color: #000000;
   scrollbar-3dlight-color: #8FAFCF;
}
</style>
</head><body bgcolor="$colours{bgcolor}" text="$colours{text}">
EOF
}

# The footer to print at user /quit
sub footer{
   print <<EOF;
</body></html>
EOF
}

# The ipaccess access checking, subroutine, reads the ipaccess file
sub check_ip{
   my $ip=$ENV{REMOTE_ADDR};
   my ($allow);
   open(IPS, "$config{ip_access}") || error("Unable to open access list");
   while(<IPS>){
	  chomp;
	  next if /^#/;
	  s/\./\\./g;
	  s/\*/\\d\*/g;
	  if(s/^\!// and $ip =~ /$_/){
		 &ip_blocked;
	  }else{
		 if($ip =~ /$_/){
			$allow=1;
		 }
	  }
   }
   close(IPS);
   if(!$allow){
	  &ip_blocked;
   }
}

# Returns the ip blocked error message
sub ip_blocked{
   error("Your IP ($ENV{REMOTE_ADDR}) is blocked from accessing this program, please email the administator of the system if you feel this is incorrect",$colours{client});
}

# Checks the referer so the script can't be linked from other sites
sub check_referer{
   return 0 if !$ENV{HTTP_REFERER} || !$ENV{SERVER_NAME};
   if($ENV{HTTP_REFERER} !~ /^http:\/\/\Q$ENV{SERVER_NAME}\E/i){
	  error("Your Referer ($ENV{HTTP_REFERER}) does not allow access to this program",$colours{client});
   }
}

# Removes stale unix-domain sockets from the temp. dir
sub rm_stale{
   $config{tmpfile_prefix} =~ /^(.*)\/([^\/]*)$/;
   my ($dir,$prefix)=($1,$2);
   opendir(TMP, $dir);
   while($_ = readdir(TMP)){
	  next if $_ !~ /^\Q$prefix\E/;
	  if((stat($dir."/".$_))[8] < time-7000){
		 unlink($dir."/".$_);
	  }
   }
   closedir(TMP);
}

# Reads the styles, into the %colours hash
sub styles{
   $config{style}=$q->param('style');
   if($config{style}){
	  ($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp},$colours{link}) = split(/:/,$styles{$config{style}});
   }else{
	  ($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp},$colours{link}) = split(/:/,$styles{$config{default_style}});
   }
}

# Reads the cgi_input
sub cgi_input{
   $config{nick}=$q->param('n') || $config{nick} || error("You must specify a nick name");
   $config{nick} =~ s/( |:)//g;
   $config{name}=$q->param('l') || $config{default_name};
   $config{server}=$q->param('s') || $config{default_server};
   $config{port}=$q->param('p') || $config{default_port};
   $config{m}=$q->param('m');
   $config{u}=$q->param('u');
   for(split(/( |,)/,$q->param('c'))){
	  next if $_ !~ /^\S/;
	  $_=lc($_);
      $channels{$_}=1; 
   }
   $config{random}=$q->param('r') || error("Random Value not set");
   if($config{random} =~ /[^A-Za-z0-9]/){
	  error("Random value contains invaild characters");
   }
}

# Reads the config file into the hashes
sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) || error("Unable to open config file");
   while(<CONFIG>){
	  chomp;
	  next if /^(#|;)/;
	  next if $_ !~ /^\S/;
	  if(/^\[(\w*)\]$/){
		 my $tmp=$1;
		 $section= \%$tmp;
	  }else{
		 my($key,$value)=split(/=/,$_,2);
		 $$section{$key}=$value;
	  }
   }
   close(CONFIG);
}
	  
# ----------------------- The main loop -----------
sub main{
   connect_to_server($config{server},$config{port});

# Set-up the listener on the unix-domain socket
   $add = new IO::Socket::UNIX(
		 Listen => 1, 
		 Local => "$config{tmpfile_prefix}$config{random}"
   ) || error("Cannot create UNIX Domain Socket: $!");
# The IO::Select stuff
   my $sel = new IO::Select( $remote, $add);
   my @ready;
   while(1){
	  @ready = $sel->can_read(8);
# Make sure the broswer keeps the connection open
	  if(!@ready){
		 print "<!-- nothing comment -->\n";
	  }
      foreach my $fh (@ready) {
# IRC input
	     if($fh == $remote){
			my ($char,$tmp);
			while (sysread($fh, $char, 1)) { $tmp .= $char; last if $char eq "\n"}
		    if($tmp eq ""){
			   &closefiles;
		    }else{
			   irc_check_command($tmp);
		    }
# New Unix-domain socket
	     }elsif($fh == $add){
		    my $new = $add->accept;
		    $sel->add($new);
	     }else{
# Input on a unix-domain socket
            my($char, $tmp);
            while (sysread($fh, $char, 1)) {last if $char eq "\n"; $tmp .= $char}
			udsocket($tmp,$fh,$sel);
	     }
      }
   }
   &closefiles;
   exit 0;
}

# Deal with the unix-domain socket, and either write text or run / commands
sub udsocket{
   my ($tmp,$fh,$sel)=@_;
   if($tmp eq "" || $tmp eq "/CLOSESOCKET"){
	  $sel->remove($fh);
	  $fh->close;
	  next;
   }elsif($tmp eq "/STATUS"){
	  syswrite($fh,join(" ",keys(%channels))."\n");
	  syswrite($fh,$default_channel."\n");
	  syswrite($fh,$config{nick}."\n");
	  syswrite($fh,$config{server}."\n");
   }elsif($tmp =~ /^\/UCTOPIC\s(\S*)/){
	  syswrite($fh,$topic{lc($1)}."\n");
   }elsif($tmp =~ /^\/CHANNELUSERLIST\s(\S*)/){
	  my $channel=lc($1);
	  my $tmp;
	  for(keys %{$channels{$channel}}){
		 if(${$channels{$channel}}{$_} == 1){
			$tmp.= $_." "; 
		 }elsif(${$channels{$channel}}{$_}){
			$tmp.= ${$channels{$channel}}{$_}.$_." "; 
		 }	
	  }
	  $tmp =~ s/\s+$//;
	  syswrite($fh,$tmp."\n");
   }elsif($tmp =~ /^\/UCMODES\s(\S*)/){
	  syswrite($fh,$modes{$1}."\n");
   }elsif($tmp=~ s/^\///){
	  slashcmd($tmp);
   }else{
	  irc_server_speech($default_channel, $tmp);
   }
}	

# ------------------------- Misc. Stuff -----------
# Add and remove channels from the hash (%channels)
sub channels_add{
   my $channel=lc(shift);
   $channels{$channel}=1;
   &reload_bottom;
}

# Delete a channel from the hash
sub channels_del{
   my $channel=lc(shift);
   delete($channels{$channel});
   &reload_bottom;
}

# Add a user the the list for the channel
sub user_add{
   my $channel=shift;
   my $channel=lc($channel);
   for(@_){
	  if(s/^(\@|\+)//){
		 my $me = $1;
		 ${$channels{$channel}}{$_} = $me;
	  }else{
		 ${$channels{$channel}}{$_} = 1;
	  }
   }
}

# Delete a yser from the list for a channel
sub user_del{
   my ($channel, $nick)=@_;
   $channel=lc($channel);
   my $tmp = ${$channels{$channel}}{$nick};
   ${$channels{$channel}}{$nick} = undef;
   return($tmp) if $tmp != 1;
}

sub user_mod{
   my($channel,$action,$mode,$user)=@_;
   $channel = lc($channel);
   $mode = "\@" if $mode eq "o";
   $mode = "+" if $mode eq "v";
   if($action eq "+"){
	  ${$channels{$channel}}{$user} = $mode;
   }else{
	  ${$channels{$channel}}{$user} = 1;
   }
}

# This reloads the bottom frame
sub reload_bottom{
   print "<script><!--\nparent.form.window.location='$config{irc_form}?action=form\&r=$config{random}\&style=$config{style}\&chan-default=".$q->escape($default_channel)."\&m=$config{m}'\n//-->\n</script>\n";
}

sub reload_userlist{
   print "<script><!--\nparent.userlist.window.location='$config{irc_userlist}?r=$config{random}\&style=$config{style}'\n//-->\n</script>\n" if $config{u};
}

# Run on exit to close files
sub closefiles{
   syswrite($remote,"QUIT :$config{version_string} \002[\002EOF\002]\002");
#close($add);
#close($remote);
   unlink("$config{tmpfile_prefix}$config{random}");
   sleep(1);
   exit(0);
}

# Used in access control list, see the docs in the config file for more info
sub check_regex{
   my ($regex,$input)=@_;
   if($regex =~ s/^\!//){
	  if($input =~ /^$regex$/){
		 return 0;
	  }else{
		 return 1;
	  }
   }else{
	  if($input =~ /^$regex$/){
		 return 1;
	  }else{
		 return 0;
	  }
   }
}

# Encode IP for use in realname (see decode.pl for a quick way to decode it)
sub encode_ip{
   my @ips=split(/\./, $_[0]);
   my $ip_encoded;
   for(@ips){
	  my $tmp;
	  $tmp=sprintf("%x", $_);
	  if(length($tmp) < 2){
		 $tmp="0".$tmp;
	  }
	  $ip_encoded.=$tmp;
   }
   return $ip_encoded;
}

   
# ---------------------- Connection to server --------
sub connect_to_server{
    my($server,$port)=@_;
	if(!&check_regex($config{access_servers},$server)){
	   error("$config{echo_string} sorry access to server $server is denied");
	}
    html("Connecting to $server:$port",$colours{server});
	my $suser = lc($config{nick});
	$suser =~ s/[^a-z0-9]//g;
	my $ip_encoded = encode_ip($ENV{REMOTE_ADDR}) if $config{encoded_ips};
	if($config{ident} eq 2){
	   $suser = lc($ip_encoded);
	}
	$ip_encoded = "[$ip_encoded] ";
    $remote = IO::Socket::INET->new(
		  Proto     => "tcp",
		  LocalAddr => $config{vhost},
		  PeerAddr  => $server,
		  PeerPort  => $port,
    ) || error("Cannot connect to $server: $!",$colours{server});
	if($config{ident}){
	   identd($remote->sockport,$remote->peerport,$suser,time);
	}
    irc_server_raw("NICK", "$config{nick}");
    irc_server_raw("USER", "$suser $config{default_mode} $suser :$ip_encoded$config{name}");
}

# Deal with ident
sub identd{
   open(IDENTD, ">>$config{ident_file}");
   print IDENTD join(":",@_),"\n";
   close(IDENTD);
}

# ---------------- Input from server -------------
sub irc_check_command{
    my $response = shift;
	$response =~ s/(\015\012|\012)$//;
	my ($prefix,$command,$text)=split(/:/,$response,3);
	
    if ("PING" eq substr $prefix, 0, 4){
	   irc_server_raw("PONG",":$command");
	}elsif($prefix =~ /^NOTICE/){
	   html($command.$text,$colours{server});
	}elsif($prefix =~ /^ERROR/){
	   html($command.$text,$colours{server});
	   if($command eq "Closing Link"){
		  &closefiles;
	   }
    } else {
	   my @bits = split(/ /, $command);
	   my ($remote_nick,$remote_host) = split "!", $bits[0];
	   if($irc{$bits[1]}){
		  eval($irc{$bits[1]});
	   }else{
		  if(lc($bits[2]) eq lc($config{nick})){
			 eval("shift(\@bits);" x 3);
			 html("$config{echo_string} ".join(" ",(@bits,$text)),$colours{server});
		  }else{
			 html("!".join(" ",@bits)." ".$text,$colours{server});
		  }
	   }
   }
}

sub irc_quit_handler{
   my($remote_nick,$text)=@_;
   if($remote_nick eq $config{nick}){
	  &closefiles
   }else{
	  for(keys %channels){
		 &user_del($_,$remote_nick);
	  }
	  &reload_userlist;
   }
   1;
}

# Deletes users from the list, or the user if they left
sub irc_part_handler{
   my($remote_nick,$channel)=@_;
   if($remote_nick eq $config{nick}){
	  &channels_del($channel);
   }else{
	  &user_del($channel,$remote_nick);
   }
   &reload_userlist;
   1;
}

# Checks if the user can join the channel and adds to the list
sub irc_join_handler{
   my($remote_nick,$channel)=@_;
   if($remote_nick eq $config{nick}){
	  if(!&check_regex($config{access_channels}, $channel)){
		 html("$config{echo_string} sorry access to $channel is denied",$colours{client});
		 irc_server_raw("PART",$channel." :\002[\002CGI\002:\002IRC\002]\002 Access Denied");
	  }else{
		 &channels_add($channel);
	  }
   }else{
	  &user_add($channel, $remote_nick);
   }
   &reload_userlist;
   1;
}

# Change nick
sub irc_nick_handler{
   my($remote_nick,$act_nick)=@_;
   if($remote_nick eq $config{nick}){
	  $config{nick}=$act_nick;
   }
   for(keys %channels){
	  my $mode=user_del($_,$remote_nick);
	  &user_add($_,$mode.$act_nick);
   }
   &reload_userlist;
   1;
}

sub irc_kick_handler{
   my($remote_nick,$act_nick,$channel)=@_;
   if($remote_nick eq $config{nick}){
	  &channel_del($channel);
# auto-rejoin?
	}else{
	  &user_del($channel,$act_nick)
	}
	&reload_userlist;
   1;
}

# Server messages, CTCP and notices
sub irc_notice_handler{
   my($remote_nick,$remote_channel,$text)=@_;
   if($remote_nick eq $config{server}){
	  $text =~ s/^\*\*\*//;
	  html("$config{echo_string} $text",$colours{server});
   }elsif("\001" eq substr($text,0,1)){
	  $text =~ /^\001(\S*)\s*(.*)\001$/;
	  my($ctcp_command,$ctcp_params)=($1,$2);
	  if($ctcp_command eq "PING"){
		 my $pingtime=time-$ctcp_params;
		 html("$config{echo_string} CTCP PING reply from $remote_nick $pingtime seconds",$colours{ctcp});
	  }else{
		  html("$config{echo_string} CTCP $ctcp_command reply from $remote_nick: $ctcp_params", $colours{ctcp});
	  }
   }else{
	  html("*$remote_nick* $text",$colours{mesg});
   }
   1;
}

# Topic changed (or RPL_TOPIC)
sub irc_topic_handler{
   my($remote_nick,$channel,$text)=@_;
   $topic{lc($channel)}=$text;
   1;
}

sub irc_mode_handler{
   my @mode=split(/ /,$_[0]);
   if($mode[0] eq $config{nick}){
	  my($action) = substr($mode[1],0,1);
	  my $i=0;
	  while($i <= length($mode[1])){
		 my $bit=substr($mode[1],$i,1);
		 if($bit eq "+"){
			$action="+";
		 }elsif($bit eq "-"){
			$action="-";
		 }else{
			if($action eq "+"){
			   $modes{$config{nick}}.=$bit;
			}else{
			   $modes{$config{nick}} =~ s/\Q$bit\E//i;
			}
		 }
		 $i++;
	  }
   }
   return if $mode[0] !~ /^(#|&)/;
   my($action) = substr($mode[1],0,1);
   my $count=1;
   my $i=0;
   my $l=length($mode[1]);
   while($i <= $l){
	  my $bit=substr($mode[1],$i,1);
	  if($bit eq "+"){
	     $action="+";
	  }elsif($bit eq "-"){
	     $action="-";
	  }elsif($bit eq "o"){
	     $count++;
		 user_mod($mode[0],$action,"o",$mode[$count]);
	  }elsif($bit eq "v"){
	     $count++;
		 user_mod($mode[0],$action,"v",$mode[$count]);
	  }elsif($bit eq "b"){
		 $count++;
	  }else{
		 $modes{$mode[0]}.=$bit if $action eq "+";
		 $modes{$mode[0]} =~ s/\Q$bit\E//i if $action eq "-";
	  }
	  $i++;
   }
   &reload_userlist;
   1;
}

sub irc_invite_handler{
   my($remote_nick,$channel)=@_;
   1;
}

# Connection stuff
sub irc_connect_ok{
   my($nick,$server)=@_;
   $config{nick}=$nick;
   $config{server}=$server;
   $config{connected}=1;
   irc_server_raw("MODE", $config{nick}." ".$config{default_mode});
   for(keys %channels){
	  next if (length $_ < 1);
	  if(!&check_regex($config{access_channels}, $_)){
		 html("$config{echo_string} sorry access to $_ is denied",$colours{client});
		 next;
	  }
	  irc_server_raw("JOIN", $_);
	  $default_channel=$_;
   }
   undef(%channels);
   1;
}
   
# ------------------ Output to server ---------------
sub irc_server_raw{
    my ($command, $params) = @_;
    syswrite($remote,"$command $params\n");
}

# Outputs PRIVMSGs to the server and user
sub irc_server_speech{
    my ($channel,$text) = @_; 
	$text =~ s/\%B(.*?)(\%B|$)/\002$1\002/ig;
	$text =~ s/\%C(\d{1,2}(,\d{1,2}|))(.*?)(\%C|$)/\003$1$3\003/ig;
	if($channel eq $default_channel and $default_channel =~ /^(#|&|\+)/){
	   html("<$config{nick}> $text\n");
	}elsif($channel =~ /^(#|&)/){
	   html("<$config{nick}:$channel> $text\n");
	}else{
	   html("msg $channel: $text\n",$colours{mesg});
	}
    irc_server_raw("PRIVMSG","$channel :$text");
}

# Sends an emote to the server
sub irc_server_emote{
    my ($channel, $text) = @_; 
    irc_server_ctcp($channel, "ACTION", $text);
}

# Sends a ctcp to the server
sub irc_server_ctcp{
    my ($channel, $ctcpcmd, $text) = @_; 
	if($ctcpcmd eq "ACTION"){
	   html("$config{nick}/$channel: $text",$colours{action});
	}else{
	   html("CTCP->$channel:$ctcpcmd $text",$colours{ctcp}) unless($ctcpcmd eq "IGNORE");
	}
    irc_server_raw("PRIVMSG","$channel :\001$ctcpcmd $text\001");
}

# Sends a notice
sub irc_server_notice{
    my ($nick, $text) = @_; 
    irc_server_raw("NOTICE","$nick :$text");
}

# ----------------- Input from client -----------
sub slashcmd{
   my @args=split(/ /,shift);
   my $command=lc(shift(@args));
   map(s/\%B(.*?)(\%B|$)/\002$1\002/ig,@args);
   map(s/\%C(\d{1,2}(,\d{1,2}|))(.*?)(\%C|$)/\003$1$3\003/ig,@args);
   if(!$command){
	  return 0;
   }
   if(!&check_regex($config{access_commands},$command)){
	  html("$config{echo_string} sorry $command is disabled",$colours{client});
	  return 0;
   }
   if($command eq "msg" || $command eq "m"){
	  my $channel=shift(@args);
	  my $text=join(" ",@args);
	  irc_server_speech($channel, $text);
   }elsif($command eq "ctcp"){
	  irc_server_ctcp(shift(@args),uc(shift(@args)),join(" ",@args));
   }elsif($command eq "whois" || $command eq "w"){
	  irc_server_raw("WHOIS",$args[0]);
   }elsif($command eq "whowas"){
	  irc_server_raw("WHOWAS",$args[0]);
   }elsif($command eq "who"){
	  irc_server_raw("WHO",join(" ",@args));
   }elsif($command eq "list"){
	  irc_server_raw("LIST",join(" ",@args));
   }elsif($command eq "default" || $command eq "chan"){
	  $default_channel=$args[0];
   }elsif($command eq "l" || $command eq "leave" || $command eq "part"){
	  my $leave=shift(@args);
	  if(!$leave){$leave=$default_channel}
	  irc_server_raw("PART","$leave :".join(" ",@args));
   }elsif($command eq "j" || $command eq "join"){
	  for(@args){
		 my($chan,$key)=split(/,/);
		 if(!&check_regex($config{access_channels}, $chan)){
		    html("$config{echo_string} sorry access to $chan is denied",$colours{client});
	     }else{
			irc_server_raw("JOIN",$chan." ".$key);
		 }
	  }
   }elsif($command eq "nick"){
	  irc_server_raw("NICK",$args[0]);
   }elsif($command eq "me"){
	  irc_server_emote($default_channel,join(" ",@args));
   }elsif($command eq "quit" || $command eq "q"){
	  my $me=join(" ",@args);
	  if($me eq ""){$me=$config{version_string};}
	  irc_server_raw("QUIT",":".$me);
	  html("$config{echo_string} SignOff $config{nick} ($me)",$colours{enter});
	  $::quit=1;
	  html("CGI:IRC $version by David Leadbeater ($config{url})",$colours{client});
	  &footer;
	  &closefiles;
   }elsif($command eq "mode"){
	  my $channel=shift(@args);
	  if($channel =~ /^(\+|\-)/){
		 my $tmpmode;
		 $tmpmode.=$default_channel." ".$channel;
		 if(@args){
			$tmpmode.=" ".join(" ",@args);
		 }
		 irc_server_raw("MODE",$tmpmode);
	  }else{
		 irc_server_raw("MODE","$channel ".join(" ",@args));
	  }
   }elsif($command eq "kick"){
	  my $channel=shift(@args);
	  if($channel !~ /^(&|#)/){
		 irc_server_raw("KICK","$default_channel $channel :".join(" ",@args));
	  }else{
		 irc_server_raw("KICK","$channel ".shift(@args)," :".join(" ",@args));
	  }
   }elsif($command eq "topic"){
	  if(!@args){
		 irc_server_raw("TOPIC",$default_channel);
	  }else{
		 irc_server_raw("TOPIC","$default_channel :".join(" ",@args));
	  }
   }elsif($command eq "notice"){
	  html("notice $_[0]: ".join(" ",@args),$colours{notice});
	  irc_server_raw("NOTICE",shift(@args)." :".join(" ",@args));
   }elsif($command eq "INVITE"){
	  my $tmpinvite;
	  $tmpinvite=shift(@args)." ";
	  if(@args){
		 $tmpinvite.=shift(@args);
	  }else{
	     $tmpinvite.=$default_channel;
	  }
	 irc_server_raw("INVITE",$tmpinvite);
   }elsif($command eq "op"){
	  irc_server_raw("MODE","$default_channel +"."o" x scalar(@args)." ".join(" ",@args));
   }elsif($command eq "deop"){
	  irc_server_raw("MODE","$default_channel -"."o" x scalar(@args)." ".join(" ",@args));
   }elsif($command eq "voice"){
	  irc_server_raw("MODE","$default_channel +"."v" x scalar(@args)." ".join(" ",@args));
   }elsif($command eq "devoice"){
	  irc_server_raw("MODE","$default_channel -"."v" x scalar(@args)." ".join(" ",@args));
   }elsif($command eq "ban"){
	  irc_server_raw("MODE","$default_channel +b ".join(" ",@args));
   }elsif($command eq "unban"){
	  irc_server_raw("MODE","$default_channel -b ".join(" ",@args));
   }elsif($command eq "quote"){
	  irc_server_raw(shift(@args),join(" ",@args));
   }elsif($command eq "admin"){
	  irc_server_raw("ADMIN",$args[0]);
   }elsif($command eq "trace"){
	  irc_server_raw("TRACE",join(" ",@args));
   }elsif($command eq "names"){
	  irc_server_raw("NAMES",join(" ",@args));
   }elsif($command eq "ping"){
	  if(!$args[0]){$args[0]=$default_channel}
	  irc_server_ctcp($args[0],"PING",time);
   }elsif($command eq "help"){
	  html("$config{echo_string} Please see the Documentation at $config{docs}",$colours{client});
   }elsif($command eq "query"){
	  if($args[0]){
		 if($config{query}){
			delete($channels{$config{query}});
		 }
		 $config{query}=$args[0];
		 $channels{$args[0]}=1;
		 html("$config{echo_string} Starting query with $args[0]",$colours{client});
	  }else{
		 html("$config{echo_string} Ending query with $config{query}",$colours{client});
		 delete($channels{$config{query}});
		 $config{query}="";
	  }
   }else{
	  html("$config{echo_string} Unknown command '$command'\n",$colours{client});
   }
}

# ---------------- Output to client -----------------
# Deals with everthing a privmsg can contain (channel, user or ctcp)
sub irc_server_privmsg{
   my ($msg_channel, $text,$remote_nick) = @_;

# CTCP
   if ("\001" eq substr $text, 0, 1){
	  my ($ctcp_command,$ctcp_params);
	  $text =~ /^\001(\w*)( (.*)|)\001$/;
	  $ctcp_command = $1;
	  $ctcp_params = $3;
	  if ($ctcp_command eq "ACTION"){
		 if ($msg_channel eq lc $config{nick}){
			private_emote_handler($remote_nick, $ctcp_params);
		 }else{
			channel_emote_handler($msg_channel, $remote_nick, $ctcp_params);
		 }
	  }elsif($ctcp_command eq "PING"){
		 html("$config{echo_string} $remote_nick requested CTCP ping from $msg_channel",$colours{ctcp});
		 irc_server_raw("NOTICE","$remote_nick :\001PING $ctcp_params\001") if $ctcp_seconds+$config{floodtime} < time;
		 $ctcp_seconds=time;
	  }elsif($ctcp_command eq "CLIENTINFO"){
		 html("$config{echo_string} $remote_nick requested CTCP clientinfo from $msg_channel",$colours{ctcp});
		 irc_server_raw("NOTICE","$remote_nick :\001CLIENTINFO CLIENTINFO PING VERSION USERINFO\001") if $ctcp_seconds+$config{floodtime} < time;
		 $ctcp_seconds=time;
	  }elsif($ctcp_command eq "VERSION"){
		 html("$config{echo_string} $remote_nick requested CTCP version from $msg_channel",$colours{ctcp});
		 irc_server_raw("NOTICE","$remote_nick :\001VERSION $config{version_string} ($config{url})\001") if $ctcp_seconds+$config{floodtime} < time;
		 $ctcp_seconds=time;
	  }elsif($ctcp_command eq "USERINFO"){
		 html("$config{echo_string} $remote_nick requested CTCP userinfo from $msg_channel",$colours{ctcp});
		 irc_server_raw("NOTICE","$remote_nick :\001USERINFO $ENV{REMOTE_ADDR} ($ENV{HTTP_USER_AGENT})\001") if $ctcp_seconds+$config{floodtime} < time;
		 $ctcp_seconds=time;
	  }else{
		 html("Unknown CTCP $ctcp_command $ctcp_params from $remote_nick to $msg_channel",$colours{ctcp});
	  }
   }else{
	  if ($msg_channel eq lc $config{nick}){
		 private_speech_handler($remote_nick, $text);
	  } else {
		 channel_speech_handler($msg_channel,$remote_nick, $text);
	  }
   }
}

# Channel speech handler
sub channel_speech_handler{
    my ($channel, $remotenick, $text)=@_;
	if($text =~ /^\Q$config{nick}\E/i){
	   $remotenick="\003"."2$remotenick\003";
	}
	if(lc($channel) eq lc($default_channel)){
	   html("<$remotenick> $text\n");
	}else{
	   html("<$remotenick $channel> $text\n");
	}
}

# Channel emote handler
sub channel_emote_handler{
    my($channel,$remotenick,$text) = @_;
    html("$remotenick/$channel $text\n",$colours{action});
}

# Private message
sub private_speech_handler{
    my ($remotenick, $text) = @_;
    html("-$remotenick- $text\n","#ff0000");
}

# Private emote
sub private_emote_handler{
    my ($remote_nick, $text) = @_;
    html("-$remote_nick $text\n","#ffff00");
}

# Errors
sub error{
   &nph_header if !$header;
   html($_[0],$_[1]);
   exit;
}

# html output
sub html{
   my ($text,$style)=@_;
   my $me;
   chomp($text);
   $text=~ s/\&/\&amp;/g;
   $text=~ s/</\&lt;/g;
   $text=~ s/>/\&gt;/g;
   $text=~ s/([a-zA-Z]*:\/\/[^ \(\)\'\<\>\001\002\003\022\037\019\008]*)/<span class="link" onClick="window.open('\1')">\1<\/span>/g;
  $text=~ s/\002(.*?)(\002|$)/<b>$1<\/b>/g;
  $text=~ s/\022(.*?)(\022|$)/<u>$1<\/u>/g;
  $text=~ s/\037(.*?)(\037|$)/<u>$1<\/u>/g;
  $text=~ s/\019(.*?)(\019|$)/<u>$1<\/u>/g;
  $text=~ s/\008(.*?)(\008|$)/<i>$1<\/i>/g;
  $text=~ s/\003(\d{1,2})(\,(\d{1,2})|)([^]*|.*?$)/
	  $me="";
	  $me.="<font ";
	  if($3){$me.="style=\"background: ".$colours{$3}."\" "}
	  $me.="color=\"$colours{$1}\">$4<\/font>";
	  $me;
  /eg;
  $text =~ s/\003//g;
   print "<font color=\"$style\">" if $style;
   print "$text<br>";
   print "</font>" if $style;
   print "<script>$config{scroll}</script>" if $config{scroll};
   print "\n";
}


